package
{

	import flash.display.Bitmap;
	import org.flixel.*;

	public class PlayState extends FlxState
	{
		[Embed(source = "assets/d1.png")] private const ImgD1:Class;
		[Embed(source = "assets/d2.png")] private const ImgD2:Class;
		[Embed(source = "assets/d3.png")] private const ImgD3:Class;
		[Embed(source = "assets/d4.png")] private const ImgD4:Class;
		[Embed(source = "assets/d5.png")] private const ImgD5:Class;
		[Embed(source = "assets/ui.png")] private const ImgUI:Class;
		[Embed(source = "assets/mouth.png")] private const ImgMouth:Class;
		
		
		private var d1:FlxSprite;
		private var d2:FlxSprite;
		private var d3:FlxSprite;
		private var d4:FlxSprite;
		private var d5:FlxSprite;
		private var ds:Array;
		private var ui:FlxSprite;
		
		private var dialogtxt:FlxText;
		private var question1txt:FlxText;
		private var question2txt:FlxText;
		private var question3txt:FlxText;
		private var question1but:FlxButton;
		private var question2but:FlxButton;
		private var question3but:FlxButton;
		
		private var awards:int = 0;
		private var awardsTxt:FlxText;
		
		private var mouth:FlxSprite;
		
		private var awardsString:String = "";
		private var awardTimer:FlxTimer;
		
		private var mouthPos:Array = [
			
			new FlxPoint(193, 100),
			new FlxPoint(196, 106),
			new FlxPoint(196, 93),
			new FlxPoint(182, 100),
			new FlxPoint(184, 110)
		];
		
		private var words:Array = [
			"game mechanic",
			"monetization",
			"clones",
			"money",
			"they cloned my game",
			"gdc flu",
			"boo hoo",
			"procrastination",
			"valve",
			"braid",
			"passage",
			"jon blow",
			"minecraft",
			"notch",
			"jason rohrer",
			"sony",
			"microsoft",
			"evil publishers",
			"the app store sucks"
		];
		
		override public function create():void
		{
			ds = [];
			d1 = new FlxSprite(0, 0, ImgD1); ds.push(d1); d1.visible = false; add(d1);
			d2 = new FlxSprite(0, 0, ImgD2); ds.push(d2); d2.visible = false; add(d2);
			d3 = new FlxSprite(0, 0, ImgD3); ds.push(d3); d3.visible = false; add(d3);
			d4 = new FlxSprite(0, 0, ImgD4); ds.push(d4); d4.visible = false; add(d4);
			d5 = new FlxSprite(0, 0, ImgD5); ds.push(d5); d5.visible = false; add(d5);
			
			mouth = new FlxSprite();
			mouth.loadGraphic(ImgMouth, true, false, 25, 25);
			mouth.setOriginToCorner();
			mouth.addAnimation("talk", [0, 1, 2, 3, 4, 5, 6, 7], 8);
			mouth.addAnimation("stop", [5], 8);
			mouth.play("stop");
			mouth.scale.x = mouth.scale.y = 1.2;
			add(mouth);
			
			ui = new FlxSprite(0, 0, ImgUI); add(ui);
			
			dialogtxt = new FlxText(10, 185, FlxG.width-20, ""); add(dialogtxt);
			
			
			question1but = new FlxButton(0,0,null,clickedOne);
			question2but = new FlxButton(0,0,null,clickedTwo);
			question3but = new FlxButton(0,0,null,clickedThree);
			question1but.makeGraphic(293, 6, 0x22ffffff);
			question2but.makeGraphic(293, 6, 0x22ffffff);
			question3but.makeGraphic(293, 6, 0x22ffffff);
			add(question1but);
			add(question2but);
			add(question3but);
			question1but.x = 12; question1but.y = 213;
			question2but.x = 12; question2but.y = 221;
			question3but.x = 12; question3but.y = 229;
			
			question1txt = new FlxText(10, 210, FlxG.width-20, ""); add(question1txt);
			question1txt.setFormat(null, 6, 0x9e9d9a);
			question2txt = new FlxText(10, 218, FlxG.width-20, ""); add(question2txt);
			question2txt.setFormat(null, 6, 0x9e9d9a);
			question3txt = new FlxText(10, 226, FlxG.width-20, ""); add(question3txt);
			question3txt.setFormat(null, 6, 0x9e9d9a);
			
			
			awards = 0;
			awardsTxt = new FlxText(240, 0, 500, "0");
			awardsTxt.setFormat(null, 14);
			add(awardsTxt);
			
			awardTimer = new FlxTimer();
			
			FlxG.mouse.show();
			
			nextIndie();
			
		}
		
		override public function update():void
		{
			super.update();
			
		}
		
		private function getIndiePhrase():String
		{
			var aa:Array = words.concat();
			var s:String = ""; var iii:int;
			s += "bla";
			for (var j:int = 0; j < 4; j++) 
			{
				
				for (var i:int = 0; i < 3; i++) 
				{
					if (Math.random() > 0.65) s += " bla";
				}
				s += " " + aa.splice(Math.floor(Math.random() * aa.length),1)[0];
				
				if (Math.random() > 0.5)
				{
					for (var i:int = 0; i < 3; i++) 
					{
						if (Math.random() > 0.65) s += " bla";
					}
					s += " " + aa.splice(Math.floor(Math.random() * aa.length),1)[0];
				}
			}
			s += "."
			return s;
		}
		
		private function getIndieQuestions():Array
		{
			var aa:Array = words.concat();
			var a:Array = [];
			a.push( "bla bla " + aa.splice(Math.floor(Math.random() * aa.length), 1)[0] + "?" );
			a.push( "bla bla " + aa.splice(Math.floor(Math.random() * aa.length), 1)[0] + "?" );
			a.push( "bla bla " + aa.splice(Math.floor(Math.random() * aa.length), 1)[0] + "?" );
			return a;
		}
		private function nextIndie():void
		{
			if (awards > 1000) {
				FlxG.switchState(new WinState());
				return;
			}
			
			awardTimer.stop();
			
			var q:Array = getIndieQuestions();
			question1txt.text = q[0];
			question2txt.text = q[1];
			question3txt.text = q[2];
			question1txt.visible = question2txt.visible = question3txt.visible = false;
			awardsString = getIndiePhrase();
			dialogtxt.text = "";
			
			
			d1.visible = d2.visible = d3.visible = d4.visible = d5.visible = false;
			var ddd:int;
			ddd = Math.floor(Math.random() * ds.length);
			ds[ddd].visible = true;
			
			mouth.x = mouthPos[ddd].x;
			mouth.y = mouthPos[ddd].y;
			
			awards += 1 + Math.floor(Math.random() * 200);
			awardsTxt.text = awards.toString();
			
			txti = 0;
			awardTimer.start(0.02, 0, setText);
			mouth.play("talk", true);
		}
		
		private var txti:int = 0;
		private function setText(e:FlxTimer):void
		{
			
			dialogtxt.text += awardsString.substr(txti, 1);
			txti++;
			if (txti == awardsString.length) 
			{
				e.stop();
				mouth.play("stop", true);
				question1txt.visible = question2txt.visible = question3txt.visible = true;
			}
		}
		
		private function clickedOne():void
		{
			if (question1txt.visible) nextIndie();
		}
		private function clickedTwo():void
		{
			if (question1txt.visible) nextIndie();
		}
		private function clickedThree():void
		{
			if (question1txt.visible) nextIndie();
		}
	}
}

